USLEEP(3)

NAME
usleep - suspend execution for microsecond intervals

SYNOPSIS
/* BSD version */
#include <unistd.h>

void usleep(unsigned long usec);

/* SUSv2 version */
#define _XOPEN_SOURCE 500
#include <unistd.h>

int usleep(useconds_t usec);

DESCRIPTION
The usleep() function suspends execution of the calling process for (at least) usec microseconds. The sleep may be lengthened slightly by any system activity or by the time spent processing the call or by the granularity of system timers.

RETURN VALUE
None (BSD). Or: 0 on success, -1 on error (SUSv2).

ERRORS

EINTR
    Interrupted by a signal.

EINVAL
    usec is not smaller than 1000000. (On systems where that is considered an error.)

CONFORMING TO
4.3BSD. The SUSv2 version returns int, and this is also the prototype used by glibc 2.2.2. Only the EINVAL error return is documented by SUSv2.

NOTES
The type useconds_t is an unsigned integer type capable of holding integers in the range [0,1000000]. Programs will be more portable if they never mention this type explicitly. Use

    #include <unistd.h>
    ...
    	unsigned int usecs;
    ...
    	usleep(usecs);

This type is defined by <sys/types.h> included by <unistd.h> but glibc defines it only when _XOPEN_SOURCE has a value not less than 500, or both _XOPEN_SOURCE and _XOPEN_SOURCE_EXTENDED are defined.

The interaction of this function with the SIGALRM signal, and with other timer functions such as alarm(), sleep(), nanosleep(), setitimer(), timer_create(), timer_delete(), timer_getoverrun(), timer_gettime(), timer_settime(), ualarm() is unspecified.

This function is obsolete. Use nanosleep(2) or setitimer(2) instead.

SEE ALSO
alarm(2), getitimer(2), nanosleep(2), select(2), setitimer(2), sleep(3), ftm(7)